<template>
    <div id="general" class="content">
        <div class="header">
            <h2>General</h2>
        </div>

        <div class="container-fluid">
            <div class="row">
                <!-- Reactor Starts -->
                <div class="col-md-6 mt-5 mt-md-0">
                    <div class="row">
                        <div class="col-12">
                            <div class="panel h-100">
                                <div class="panel-heading">Hot Water Tank</div>
                                <div class="panel-body">
                                    <div class="d-flex justify-content-between align-items-start position-relative">
                                        <div :class="setDeviceStatusClass('XSV119_status', 'on', 'off-grey', 'trip')" class="component" style="width: 10rem">
                                            <div class="font-weight-bold">Hot water tank inlet</div>
                                            <div class="font-weight-normal">XSV119</div>
                                        </div>

                                        <horizontal-line-component :arrow-right="true" class="position-absolute" style="top: 17%; left: 10%" width="13rem"></horizontal-line-component>

                                        <div :class="setDeviceStatusCombineClass('LAL104_status', 'LAH104_status', 'on', 'off', 'trip')" class="component" style="height: 12rem; width: 14rem">
                                            <div class="font-weight-bold">Hot Water Tank</div>
                                            <div class="font-weight-normal">LAL104 | LAH104</div>
                                            <div class="font-weight-normal d-flex justify-content-between mt-2">
                                                <div>
                                                    <div>Level</div>
                                                    <div class="font-weight-bold">
                                                        {{ setDeviceLevelCombineClass('LAL104_status', 'LAH104_status') }}
                                                    </div>
                                                </div>

                                                <div>
                                                    <div>Temp</div>
                                                    <div class="font-weight-bold">
                                                        {{ setDeviceTemp('TT108_temp') }}
                                                    </div>
                                                </div>

                                                <div>
                                                    <div>TT108</div>
                                                </div>
                                            </div>
                                        </div>

                                        <horizontal-line-component :arrow-right="true" class="position-absolute" style="top: 8%; left: 37.5%" width="13rem"></horizontal-line-component>

                                        <div class="d-flex flex-column justify-content-center align-items-center mb-3 position-relative">
                                            <div class="component mb-5">
                                                <div>Heat Exchange</div>
                                            </div>

                                            <vertical-line-component :arrow-down="true" class="position-absolute" height="4rem" style="right: 60%; margin-top: -30%"></vertical-line-component>
                                            <vertical-line-component :arrow-up="true" class="position-absolute" height="5rem" style="right: 25%; margin-top: -30%"></vertical-line-component>

                                            <div :class="setDeviceStatusClass('TCV107', 'on', 'off-grey', 'trip')" class="component" style="width: 10rem">
                                                <div class="font-weight-bold">Valve</div>
                                                <div class="font-weight-normal">TCV107</div>
                                                <div>{{setDeviceLevel('TCV107_valve')}}</div>
                                            </div>
                                        </div>

                                        <horizontal-line-component :arrow-left="true" class="position-absolute" style="top: 8%; left: 60%" width="28rem"></horizontal-line-component>

                                        <div :class="setDeviceStatusClass('PCV105', 'on', 'off-grey', 'trip')" class="component" style="width: 8rem">
                                            <div class="font-weight-bold">Valve</div>
                                            <div class="d-flex justify-content-between mb-2">                                                
                                                <div>
                                                    <div class="font-weight-normal">PCV105</div>
                                                    <div class="font-weight-bold">{{setDeviceLevel('PCV105_valve')}}</div>
                                                </div>
                                            </div>

                                            <div>
                                                <div class="font-weight-normal">PT105</div>
                                                <div class="font-weight-bold">{{ setDevicePressure('PT105_pressure') }}</div>
                                            </div>
                                        </div>

                                        <div :class="setDeviceStatusClass('PCV106', 'on', 'off-grey', 'trip')" class="component" style="width: 8rem">
                                            <div class="font-weight-bold">Valve</div>
                                            <div class="d-flex justify-content-between mb-2">
                                                <div>
                                                    <div class="font-weight-normal">PCV106</div>
                                                    <div class="font-weight-bold">{{setDeviceLevel('PCV106_valve')}}</div>
                                                </div>
                                            </div>

                                            <div>
                                                <div class="font-weight-normal">PT106</div>
                                                <div class="font-weight-bold">{{ setDevicePressure('PT106_pressure') }}</div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="row mt-3">
                        <div class="col-12">
                            <div class="panel h-100">
                                <div 
                                    class="panel-heading" 
                                    :class="setDevicePanelAlarmStatus(`BOILER_ALARM_status`)"
                                >
                                    Boiler
                                </div>
                                <div class="panel-body">
                                    <div class="d-flex align-items-start justify-content-between position-relative">
                                        <div :class="setDeviceStatusCombineClass('LAL301_status', 'LAH301_status', 'on', 'off', 'trip')" class="component" style="height: 10rem; width: 14rem">
                                            <div class="font-weight-bold">Feed Water Tank</div>
                                            <div class="font-weight-normal">LAL301 | LAH301</div>
                                            <div class="font-weight-normal d-flex justify-content-between mt-2">
                                                <div>
                                                    <div>Level</div>
                                                    <div class="font-weight-bold">
                                                        {{ setDeviceLevelCombineClass('LAL301_status', 'LAH301_status') }}
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                        <vertical-line-component :arrow-down="true" class="position-absolute" height="6rem" style="top: 26%; left: 8%"></vertical-line-component>
                                        <vertical-line-component class="position-absolute" height="7rem" style="top: 44%; left: 12%"></vertical-line-component>
                                        <horizontal-line-component :arrow-right="true" class="position-absolute" style="top: 41.5%; left: 9%" width="20rem"></horizontal-line-component>
                                        <pump-component :status="setDeviceIconStatus('BFP1')" class="position-absolute" label-bottom="BFP1" style="top: 38%; left: 15%"></pump-component>
                                        <pump-component :status="setDeviceIconStatus('CDP1')" class="position-absolute" label-bottom="CDP1" style="top: 58%; left: 10.5%"></pump-component>

                                        <div class="component mr-5" style="width: 45%">
                                            <div class="font-weight-bold">Boiler</div>
                                            <div class="row">
                                                <div class="col-3">
                                                    <br/>
                                                    <div class="font-weight-normal">Pressure</div>
                                                </div>
                                                <div class="col-3">
                                                    <div class="font-weight-normal">PSW301</div>
                                                    <div class="font-weight-bold">{{ setDeviceIconStatusOtherType('PSW301_status') }}</div>
                                                </div>
                                                <div class="col-3">
                                                    <div class="font-weight-normal">PSW302</div>
                                                    <div class="font-weight-bold">{{ setDeviceIconStatusOtherType('PSW301_status') }}</div>
                                                </div>
                                                <div class="vl"></div>
                                                <div class="ml-1">
                                                    <div class="font-weight-normal">TT302</div>
                                                    <div class="font-weight-bold">{{ setDeviceTemp('TT302_temp') }}</div>
                                                </div>
                                            </div>

                                            <div class="row mt-1">
                                                <div class="col-4">
                                                    <div class="font-weight-normal">AL301</div>
                                                    <div class="font-weight-bold">{{ setDeviceIconStatusOtherType('AL301_status') }}</div>
                                                </div>
                                                <div class="col-4">
                                                    <div class="font-weight-normal">AL302</div>
                                                    <div class="font-weight-bold">{{ setDeviceIconStatusOtherType('AL302_status') }}</div>
                                                </div>
                                                <div class="col-4">
                                                    <div class="font-weight-normal">AL303</div>
                                                    <div class="font-weight-bold">{{ setDeviceIconStatusOtherType('AL303_status') }}</div>
                                                </div>
                                            </div>

                                            <boiler-chart-component v-if="boilerSeries!=null" :series="boilerSeries" />
                                            <div v-else style="height: 25rem" />
                                        </div>

                                        <horizontal-line-component :arrow-right="true" class="position-absolute" style="top: 13%; left: 61.5%" width="24rem"></horizontal-line-component>

                                        <div class="position-absolute" style="top: 8.5%; right: 15%; font-size: 1.2rem">
                                            <div class="component p-2">
                                                <div class="font-weight-normal">TT301</div>
                                                <div class="font-weight-bold">{{ setDeviceTemp('TT301_temp') }}</div>
                                            </div>
                                        </div>

                                        <div>
                                            <div class="component mt-5" style="width: 10rem">
                                                <div class="font-weight-bold">Steam Trap</div>
                                                <div class="font-weight-bold">(TD Type)</div>
                                            </div>

                                            <div class="component" style="width: 10rem; margin-top: 180%">
                                                <div class="font-weight-bold">Diesel Feed Tank</div>
                                                <div class="font-weight-normal">LT301</div>
                                                <div class="font-weight-bold">{{ setDeviceLevelHighLow('LT301_status') }}</div>
                                            </div>
                                        </div>

                                        <vertical-line-component :arrow-down="true" class="position-absolute" height="6rem" style="top: 60%; left: 92%"></vertical-line-component>
                                        <pump-component :status="setDeviceIconStatus('DSP1')" class="position-absolute" label-top="DSP1" style="top: 50%; left: 90.5%"></pump-component>
                                        <horizontal-line-component :arrow-left="true" class="position-absolute" style="top: 78%; left: 61.5%" width="24rem"></horizontal-line-component>
                                        <feed-pump-component :status="setDeviceIconStatus('BNR1')" class="position-absolute" label-bottom="BNR1" style="top: 74.5%; left: 80%"></feed-pump-component>

                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="row mt-3">
                        <div class="col-12">
                            <div class="panel h-100">
                                <div class="panel-heading">Chiller</div>
                                <div class="panel-body">
                                    <div class="row">
                                        <div class="col-7 position-relative">
                                            <div class="d-flex justify-content-between">
                                                <div class="component" style="height: 10rem">
                                                    <div class="font-weight-bold">Chiller</div>
                                                    <div class="font-weight-normal">CHR1
                                                        <span :class="setDeviceStatusClass('CHR1', 'on', 'off', 'trip')" class="font-weight-bold on mx-5">
															{{ setDeviceStatusText('CHR1_chiller') }}
														</span>
                                                    </div>
                                                    <div class="font-weight-normal">Supply temp
                                                        <span :class="setDeviceStatusClass('CHR1', 'on', 'off', 'trip')" class="font-weight-bold on mx-5">
															{{ getChillerSupplyTemp('CHR1_chiller') }}
														</span>
                                                    </div>
                                                    <div class="font-weight-normal">Set temp
                                                        <span :class="setDeviceStatusClass('CHR1', 'on', 'off', 'trip')" class="font-weight-bold on mx-5">
															{{ getChillerSetTemp('CHR1_chiller') }}
														</span>
                                                    </div>
                                                </div>

                                                <horizontal-line-component :arrow-right="true" class="position-absolute" style="top: 8%; left: 30%" width="16rem"></horizontal-line-component>
                                                <horizontal-line-component :arrow-left="true" class="position-absolute" style="top: 20%; left: 22%" width="20rem"></horizontal-line-component>
                                                <pump-component :status="setDeviceIconStatus('CWP1')" class="position-absolute" label-bottom="CWP1" style="top: 15%; left: 49%"></pump-component>

                                                <div :class="setDeviceStatusCombineClass('LAL105_status', 'LAH105_status', 'on', 'off', 'trip')" class="component" style="height: 10rem">
                                                    <div class="font-weight-bold">Chilled Water Tank</div>
                                                    <div class="font-weight-normal">LAL105 | LAH105</div>
                                                    <div class="font-weight-normal d-flex justify-content-between">
                                                        <div>
                                                            <div>Level</div>
                                                            <div class="font-weight-bold">
                                                                {{ setDeviceLevelCombineClass('LAL105_status', 'LAH105_status') }}
                                                            </div>
                                                        </div>

                                                        <div>
                                                            <div>Temp</div>
                                                            <div class="font-weight-bold">
                                                                {{ setDeviceTemp('TT110_temp') }}
                                                            </div>
                                                        </div>

                                                        <div>
                                                            <div>TT110</div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="col-5">
                                            <chiller-chart-component v-if="chillerSeries!=null" :series="chillerSeries" />
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="col-md-6 mt-5 mt-md-0">
                    <div class="row">
                        <div class="col-12">
                            <div class="panel h-100">
                                <div class="panel-heading">Latex Tank</div>
                                <div class="panel-body">
                                    <div class="row">
                                        <div class="col-3">
                                            <div>Level LT103</div>
                                        </div>

                                        <div class="col-3">
                                            <div>{{ setDeviceLevel('LT103_level') }}</div>
                                        </div>

                                        <div class="col-3">
                                            <div>Stirrer MXR3</div>
                                        </div>

                                        <div class="col-3">
                                            <div>{{ setDeviceStatusText('MXR3') }}</div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="row mt-3">
                        <div class="col-12">
                            <div class="panel h-100">
                                <div class="panel-heading" 
                                    :style="`background-color: ${setDevicePanelStatus(`DRYER_status`)}`"
                                >
                                    Dryer
                                </div>
                                <div class="panel-body">
                                    <div class="row">
                                        <!-- Pusher -->
                                        <div class="col-4">
                                            <div class="panel h-100">
                                                <div class="panel-heading">Pusher</div>
                                                <div class="panel-body">
                                                    <div class="row mt-2">
                                                        <div class="col-6">Trolley count</div>
                                                        <div class="col-6 font-weight-bold">{{ getCounter('TROLLEY_CNT_counter') }}</div>
                                                    </div>
                                                    <div class="row mt-2">
                                                        <div class="col-6">Avg trolley count</div>
                                                        <div class="col-6 font-weight-bold">{{ avgTrolleySpeedCount }}/hr</div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                        <!-- In -->
                                        <div class="col-4">
                                            <div class="panel h-100">
                                                <div class="panel-heading">IN</div>
                                                <div class="panel-body">
                                                    <div class="row mt-2">
                                                        <div class="col-4">THT501</div>
                                                        <div class="col-4 font-weight-bold">
                                                            {{ setDeviceTemp('THT501_temp') }}
                                                        </div>
                                                        <div class="col-4 font-weight-bold">
                                                            {{ setDeviceLevel('THT501_humid') }}
                                                        </div>
                                                    </div>

                                                    <div class="row mt-2">
                                                        <div class="col-4">TT503</div>
                                                        <div class="col-4 font-weight-bold">
                                                            {{ setDeviceTemp('TT503_temp') }}
                                                        </div>
                                                        <!-- <div class="col-4 font-weight-bold">
                                                            {{ setDeviceLevel('THX503') }}
                                                        </div> -->
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                        <!-- Out -->
                                        <div class="col-4">
                                            <div class="panel h-100">
                                                <div class="panel-heading">OUT</div>
                                                <div class="panel-body">
                                                    <div class="row mt-2">
                                                        <div class="col-4">THT502</div>
                                                        <div class="col-4 font-weight-bold">
                                                            {{ setDeviceTemp('THT502_temp') }}
                                                        </div>
                                                        <div class="col-4 font-weight-bold">
                                                            {{ setDeviceLevel('THT502_humid') }}
                                                        </div>
                                                    </div>

                                                    <div class="row mt-2">
                                                        <div class="col-4">TT504</div>
                                                        <div class="col-4 font-weight-bold">
                                                            {{ setDeviceTemp('TT504_temp') }}
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>

                                    <div class="row mt-3">
                                        <div class="col-12" v-if="dryerSeries!=null">
                                            <dryer-chart-component :series="dryerSeries"/>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="row mt-3">
                        <div class="col-12">
                            <div class="panel h-100">
                                <div class="panel-heading">Packaging</div>
                                <div class="panel-body row" style="min-height: 20rem">
                                    <!-- Pusher -->
                                    <div class="col-4" style="max-height: 15rem">
                                        <div class="panel h-100">
                                            <div class="panel-heading">Counter</div>
                                            <div class="panel-body">
                                                <div class="row mt-2">
                                                    <div class="col-6">Counts</div>
                                                    <div class="col-6 font-weight-bold">{{ getCounter('CNT1_counter') }}</div>
                                                </div>
                                                <div class="row mt-2">
                                                    <div class="col-6">Average</div>
                                                    <div class="col-6 font-weight-bold">{{ durationPerTrolley }}/min</div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>  
                                    <div class="col-8" v-if="trolleySeries!=null">
                                        <trolley-chart-component :series="trolleySeries"/>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="row mt-3">
                        <div class="col-12">
                            <div class="panel h-100">
                                <div class="panel-heading">Water treatment</div>
                                <div class="panel-body row">
                                    <div class="col-4">
                                        <div class="panel h-100">
                                            <div class="panel-heading">Tank level</div>
                                            <div class="panel-body">
                                                <div class="row mt-2">
                                                    <div class="col-6">Water level</div>
                                                    <div class="col-6 font-weight-bold">{{ setDeviceLevelHighLow('WTS_LEVEL_status') }}</div>
                                                </div>
                                            </div>
                                        </div>
                                    </div> 
                                    <div class="col-4">
                                        <div class="panel h-100">
                                            <div class="panel-heading">Waste water</div>
                                            <div class="panel-body">
                                                <div class="row mt-2">
                                                    <div class="col-6">LT401</div>
                                                    <div class="col-6 font-weight-bold">{{ setDeviceLevel('LT401_level') }}</div>
                                                </div>
                                            </div>
                                        </div>
                                    </div> 
                                    <div class="col-4">
                                        <div class="panel h-100">
                                            <div class="panel-heading">Ph value</div>
                                            <div class="panel-body">
                                                <div class="row mt-2">
                                                    <div class="col-6">PHT401</div>
                                                    <div class="col-6 font-weight-bold">{{ setDevicePH('PHT401_ph') }}</div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>                                      
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import DryerChartComponent from './DryerChart'
import ChillerChartComponent from './ChillerChart'
import BoilerChartComponent from './BoilerChart'
import TrolleyChartComponent from './TrolleyChart'
import HorizontalLineComponent from "../../components/productions/HorizontalLine";
import PumpComponent from "../../components/productions/Pump";
import FeedPumpComponent from "../../components/productions/FeedPump";
import VerticalLineComponent from "../../components/productions/VerticalLine";
import deviceMixin from "../../mixins/device";
import timeMixin from "../../mixins/time";
import {topics} from "../../utils/mqtt-topics";
import { CHART_INTERVAL } from "../../utils/constant";
import ProductService from "@/services/ProductService";
import TemperatureService from "@/services/TemperatureService";
import PressureService from "@/services/PressureService";
import TrolleyChart from './TrolleyChart.vue'

const NOW_TIMESTAMP = new Date().getTime()

export default {
    name: 'GeneralComponent',
    mixins: [
        deviceMixin,
        timeMixin
    ],
    components: {
        'dryer-chart-component': DryerChartComponent,
        'chiller-chart-component': ChillerChartComponent,
        'boiler-chart-component': BoilerChartComponent,
        'trolley-chart-component': TrolleyChartComponent,
        'horizontal-line-component': HorizontalLineComponent,
        'vertical-line-component': VerticalLineComponent,
        'pump-component': PumpComponent,
        'feed-pump-component': FeedPumpComponent
    },
    data() {
        return {
            device: {},
            topics: topics.generalPage,
            avgTrolleySpeedCount: "-",
            durationPerTrolley: "-",
            chillerSeries: null,
            boilerSeries: null,
            dryerSeries: null,
            trolleySeries: null
        }
    },
    computed: {
        productService: function() {
            return new ProductService();
        },

        temperatureService: function() {
            return new TemperatureService();
        },

        pressureService: function() {
            return new PressureService();
        }
    },
    mqtt: {
        'lgm/device/+'(message, topic) {
            // console.log("\nGeneral - Received message from " + topic + " topic at " + new Date().toLocaleString()
            //     + "\n" + message.toString())

            message = JSON.parse(message.toString());

            this.$set(this.device, message.device_id, message);
        },
        'lgm/data/+/+'(message, topic) {
            // console.log("\nGeneral - Received message from " + topic + " topic at " + new Date().toLocaleString()
            //     + "\n" + message.toString())

            message = JSON.parse(message.toString());

            this.$set(this.device, message.device_id + '_' + message.type, message);
        }
    },
    mounted() {
        this.$mqtt.subscribe(this.topics, function (err, granted) {
            if (err) {
                console.log("Hot Water Tanks - Error During Subscription :" + err);
            } else {
                // console.log("Hot Water Tanks - No Error During Subscription");
            }
            if (granted !== undefined) {
                // granted.forEach(function (grant) {
                //     console.log("Hot Water Tanks - Subscribed to topic " + grant.topic);
                // })
            }
        });

        this.getChillerChart()
        this.getBoilerChart()
        this.getDryerChart()
        this.getTrolleyTotalCount()
        this.getDurationPerTrolley()
        this.getOutput()
    },
    beforeDestroy() {
        if (this.topics.length > 0) {
            this.$mqtt.unsubscribe(this.topics);
        }
    },
    methods: {
        async getChillerChart() {
            let start = this.get12AMTimestamp(NOW_TIMESTAMP);

            let series =  {
                xAxis: [],
                yAxis: [
                    {
                        name: 'TT110',
                        color: '#26A69A'
                    }
                ],
            }

            let tt110 = await this.temperatureService.getTemperatureReadingByDevice("TT110", start, NOW_TIMESTAMP, CHART_INTERVAL)
            
            series.yAxis[0].data = tt110.data.data.map((item) => item.temperature);
            series.xAxis = tt110.data.data.map((item) => {
                return this.timestampToTime(item.timestamp);
            });

            this.chillerSeries = series
        },

        async getBoilerChart() {
            let start = this.get12AMTimestamp(NOW_TIMESTAMP);

            let series =  {
                xAxis: [],
                yAxis: [
                    {
                        name: 'PSW301',
                        color: '#29B6F6'
                    },
                    {
                        name: 'PSW302',
                        color: '#03A9F4'
                    },
                    {
                        name: 'TT302',
                        color: '#26A69A'
                    }
                ],
            }

            let psw301 = await this.pressureService.getPressureReadingByDevice("PSW301", start, NOW_TIMESTAMP, CHART_INTERVAL)
            let psw302 = await this.pressureService.getPressureReadingByDevice("PSW302", start, NOW_TIMESTAMP, CHART_INTERVAL)
            let tt302 = await this.temperatureService.getTemperatureReadingByDevice("TT302", start, NOW_TIMESTAMP, CHART_INTERVAL)
            
            series.yAxis[0].data = psw301.data.data.map((item) => item.pressure);
            series.yAxis[1].data = psw302.data.data.map((item) => item.pressure);
            series.yAxis[2].data = tt302.data.data.map((item) => item.temperature);
            series.xAxis = tt302.data.data.map((item) => {
                return this.timestampToTime(item.timestamp);
            });

            this.boilerSeries = series
        },

        async getDryerChart() {
            let series =  {
                xAxis: [],
                yAxis: [
                    {
                        name: 'THT501 humid',
                        color: '#29B6F6'
                    },
                    {
                        name: 'THT502 humid',
                        color: '#03A9F4'
                    },
                    {
                        name: 'THT501 temp',
                        color: '#26A69A'
                    },
                    {
                        name: 'THT502 temp',
                        color: '#009688'
                    },
                    {
                        name: 'TT503',
                        color: '#00897B'
                    },
                    {
                        name: 'TT504',
                        color: '#00796B'
                    },
                ],
            }

            let nowTimestamp = new Date().getTime()
            let start = this.get12AMTimestamp(nowTimestamp);

            try {
                let tht501humid = await this.temperatureService.getHumidityReadingByDevice("THT501", start, nowTimestamp, CHART_INTERVAL)
                let tht502humid = await this.temperatureService.getHumidityReadingByDevice("THT502", start, nowTimestamp, CHART_INTERVAL)
                let tht501 = await this.temperatureService.getTemperatureReadingByDevice("THT501", start, nowTimestamp, CHART_INTERVAL)
                let tht502 = await this.temperatureService.getTemperatureReadingByDevice("THT502", start, nowTimestamp, CHART_INTERVAL)
                let tt503 = await this.temperatureService.getTemperatureReadingByDevice("TT503", start, nowTimestamp, CHART_INTERVAL)
                let tt504 = await this.temperatureService.getTemperatureReadingByDevice("TT504", start, nowTimestamp, CHART_INTERVAL)

                if (tht501humid.data.data) {
                    series.yAxis[0].data = tht501humid.data.data.map((item) => item.humidity);
                }
                if (tht502humid.data.data) {
                    series.yAxis[1].data = tht502humid.data.data.map((item) => item.humidity);
                }
                if (tht501.data.data) {
                    series.yAxis[2].data = tht501.data.data.map((item) => item.temperature);
                }
                if (tht502.data.data) {
                    series.yAxis[3].data = tht502.data.data.map((item) => item.temperature);
                }
                series.yAxis[4].data = tt503.data.data.map((item) => item.temperature);
                series.yAxis[5].data = tt504.data.data.map((item) => item.temperature);
                series.xAxis = tt504.data.data.map((item) => {
                    return this.timestampToTime(item.timestamp);
                });
            } catch (error) {
                console.error(error)
            }

            this.dryerSeries = series
        },

        async getTrolleyTotalCount() {
            let nowTimestamp = new Date().getTime()
            let start = this.get12AMTimestamp(nowTimestamp);
            let avgTrolleySpeedCount = await this.productService.getTrolleyTotalCount(start, nowTimestamp, CHART_INTERVAL)
            this.avgTrolleySpeedCount = avgTrolleySpeedCount.data.data
        },

        async getDurationPerTrolley() {
            let nowTimestamp = new Date().getTime()
            let start = this.get12AMTimestamp(nowTimestamp);
            let durationPerTrolley = await this.productService.getDurationPerTrolley(start, nowTimestamp)
            if(durationPerTrolley.data.data !== undefined) {
                this.durationPerTrolley = durationPerTrolley.data.data
            }
        },

        async getOutput() {
            let nowTimestamp = new Date().getTime()
            let start = this.get12AMTimestamp(nowTimestamp);
            let output = await this.productService.getOutput(start, nowTimestamp, CHART_INTERVAL)

            let series =  {
                xAxis: [],
                yAxis: [
                    {
                        name: 'Trolley count',
                        color: '#039BE5'
                    },
                ],
            }
            series.yAxis[0].data = output.data.data.map((item) => item.count);
            series.xAxis = output.data.data.map((item) => {
                return this.timestampToTime(item.timestamp);
            });

            this.trolleySeries = series
        }
    }
}
</script>

<style lang="scss" scoped>
@import "../../assets/styles/pages/general/general.scss";
</style>